Imports System.Linq
Imports BankDemo.Cqrs.CommandStack.Aggregates
Imports BankDemo.Cqrs.QueryStack.ReadModel
Imports BankDemo.Models
Imports Memento.Persistence

Namespace BankDemo.Application
	Public Class DashboardService
		Private privateRepository As IRepository
		Public Property Repository As IRepository
			Get
				Return privateRepository
			End Get
			Private Set(ByVal value As IRepository)
				privateRepository = value
			End Set
		End Property

		Public Sub New(ByVal repository As IRepository)
			Me.Repository = repository
		End Sub

		Public Function GetDashboardViewModel() As DashboardViewModel
			Dim model = New DashboardViewModel
			Using db = New ProjectionManager
				model.Pending = (
				    From req In db.Requests
				    Select req).ToList()
				Return model
			End Using
		End Function

		Public Function GetRequestDetails(ByVal requestId As Guid) As RequestDetailsViewModel
			Dim request = Repository.GetById(Of AccountRequest)(requestId)
			Dim model = New RequestDetailsViewModel With {.PendingRequest = request}
			Return model
		End Function
	End Class
End Namespace
