Imports BankDemo.Cqrs.CommandStack.Commands
Imports BankDemo.Models
Imports Memento.Messaging.Postie

Namespace BankDemo.Application
	Public Class RequestService
		Private privateBus As IBus
		Public Property Bus As IBus
			Get
				Return privateBus
			End Get
			Private Set(ByVal value As IBus)
				privateBus = value
			End Set
		End Property

		Public Sub New(ByVal bus As IBus)
			Me.Bus = bus
		End Sub

		Public Sub ApplyRequestForNewBankAccount(ByVal input As NewAccountRequestViewModel, ByVal connectionId As String)
			Dim command = New RequestNewBankAccountCommand(input.FullName, input.Age, input.IsNew)
			command.SignalRConnectionId = connectionId
			Bus.Send(command)
		End Sub
	End Class
End Namespace
