Imports Hello1.CommandStack.Events
Imports Memento.Domain

Namespace BankDemo.Cqrs.CommandStack.Aggregates
	Public Class AccountRequest
		Inherits Aggregate
        Implements IApplyEvent(Of AccountRequestReceivedEvent)

        Public Property RequestId As Guid

		Public Property Received As Date

		Public Property CustomerName As String

		Public Property Age As Integer

		Public Property IsNew As Boolean

		Public Sub ApplyEvent(<AggregateId("RequestId")> ByVal theEvent As AccountRequestReceivedEvent)
			RequestId = theEvent.RequestId
			Received = Date.UtcNow
			Age = theEvent.Age
			IsNew = theEvent.IsNewCustomer
			CustomerName = theEvent.FullName
		End Sub

        Private Sub IApplyEvent_ApplyEvent([event] As AccountRequestReceivedEvent) Implements IApplyEvent(Of AccountRequestReceivedEvent).ApplyEvent
            Throw New NotImplementedException()
        End Sub

        Public NotInheritable Class Factory
            Private Sub New()
            End Sub

            Public Shared Function NewRequestFrom(ByVal name As String, ByVal age As Integer, ByVal isNew As Boolean) As AccountRequest
                Dim received = New AccountRequestReceivedEvent(Guid.NewGuid, name, age, isNew)

                ' Tell the aggregate to log the "received" event
                Dim request = New AccountRequest
                request.RaiseEvent(received)
                Return request
            End Function
        End Class
    End Class
End Namespace
