Imports Memento

Namespace BankDemo.Cqrs.CommandStack.Events
	Public Class BankAccountApprovedEvent
		Inherits DomainEvent

		Public Sub New(ByVal requestId As Guid, ByVal approver As String)
			Me.RequestId = requestId
			[When] = Date.UtcNow
			ByWhom = approver
		End Sub

		Private privateRequestId As Guid
		Public Property RequestId As Guid
			Get
				Return privateRequestId
			End Get
			Private Set(ByVal value As Guid)
				privateRequestId = value
			End Set
		End Property

		Private privateWhen As Date
		Public Property [When]() As Date
			Get
				Return privateWhen
			End Get
			Private Set(ByVal value As Date)
				privateWhen = value
			End Set
		End Property

		Private privateByWhom As String
		Public Property ByWhom As String
			Get
				Return privateByWhom
			End Get
			Private Set(ByVal value As String)
				privateByWhom = value
			End Set
		End Property
	End Class
End Namespace
