Imports BankDemo.Application
Imports BankDemo.Cqrs.CommandStack.Aggregates
Imports BankDemo.Cqrs.CommandStack.Commands
Imports BankDemo.Cqrs.CommandStack.Events
Imports Memento.Messaging.Postie
Imports Memento.Persistence

Namespace BankDemo.Cqrs.CommandStack.Sagas
	Public Class AccountRequestSaga
		Inherits Saga
        Implements IAmStartedBy(Of RequestNewBankAccountCommand), IHandleMessages(Of BankAccountApprovedEvent)

        Public Sub New(ByVal bus As IBus, ByVal eventStore As IEventStore, ByVal repository As IRepository)
			MyBase.New(bus, eventStore, repository)
		End Sub

		Public Sub Handle(ByVal message As RequestNewBankAccountCommand)
			Dim request = AccountRequest.Factory.NewRequestFrom(message.FullName, message.Age, message.IsNew)
			Repository.Save(request)

			' Notify back
			Dim hub = New AccountRequestHub
			hub.NotifyReceived(message.SignalRConnectionId, request.RequestId)
		End Sub

		Public Sub Handle(ByVal message As BankAccountApprovedEvent)
			Throw New NotImplementedException
		End Sub

        Private Sub IAmStartedBy_Handle(message As RequestNewBankAccountCommand) Implements IAmStartedBy(Of RequestNewBankAccountCommand).Handle
            Throw New NotImplementedException()
        End Sub

        Private Sub IHandleMessages_Handle(message As BankAccountApprovedEvent) Implements IHandleMessages(Of BankAccountApprovedEvent).Handle
            Throw New NotImplementedException()
        End Sub
    End Class
End Namespace
