Imports BankDemo.Cqrs.QueryStack.ReadModel
Imports Hello1.CommandStack.Events
Imports Memento.Messaging.Postie

Namespace BankDemo.Cqrs.QueryStack.Denormalizers
	Public Class AccountRequestDenormalizer
        Implements IHandleMessages(Of AccountRequestReceivedEvent)

        Public Sub Handle(ByVal message As AccountRequestReceivedEvent)
			Dim req = New PendingRequest With {.DisplayName = message.FullName, .RequestId = message.RequestId, .Category = "", .Status = "Waiting for approval"}

            ' Add a bit of fun
            Dim random1 = New Random().Next(100000)

            If random1 Mod 2 > 0 Then
				req.Status = "First level check passed"
			End If
			If message.Age < 40 Then
				req.Category &= "Under40, "
			End If
			If message.Age > 60 Then
				req.Category &= "Over60, "
			End If
			If message.IsNewCustomer Then
				req.Category &= "New, "
			End If
			req.Category = req.Category.Trim(","c, " "c).ToUpper

			Using context = New BankContext
				context.Requests.Add(req)
				context.SaveChanges()
			End Using
		End Sub

        Private Sub IHandleMessages_Handle(message As AccountRequestReceivedEvent) Implements IHandleMessages(Of AccountRequestReceivedEvent).Handle
            Throw New NotImplementedException()
        End Sub
    End Class
End Namespace
