Imports Memento.Messaging
Imports Memento.Messaging.Postie
Imports Memento.Messaging.Postie.Unity
Imports Memento.Persistence
Imports Memento.Persistence.EmbeddedRavenDB
Imports Microsoft.Practices.Unity
Imports Raven.Client.Embedded

Namespace BankDemo
	Public Class MementoStartup
		Public Shared Function UnityConfig(ByVal busType As Type, ByVal eventStoreType As Type, ByVal eventStoreDocumentType As Type, ByVal documentStore As Object) As UnityContainer
			Dim container = New UnityContainer
			container.RegisterType(Of ITypeResolver, UnityTypeResolver)(New InjectionConstructor(container))
			container.RegisterType(GetType(IBus), busType)
			container.RegisterType(GetType(IEventDispatcher), busType)

			'container.RegisterType<IBus, InMemoryBus>;
			'container.RegisterType<IEventDispatcher, InMemoryBus>;
			container.RegisterType(Of IRepository, Repository)(New InjectionConstructor(eventStoreType))

			'container.RegisterType<IRepository, Repository>(
			'    new InjectionConstructor(typeof(EmbeddedRavenDbEventStore)));

			container.RegisterType(GetType(IEventStore), eventStoreType, New InjectionConstructor(eventStoreDocumentType, GetType(IEventDispatcher)))
			'container.RegisterType<IEventStore, EmbeddedRavenDbEventStore>(
			'    new InjectionConstructor(typeof(EmbeddableDocumentStore), typeof(IEventDispatcher)));

			container.RegisterInstance(documentStore)

			Return container
		End Function

		Public Shared Function UnityConfig(Of TBus, TEventStore, TEventStoreDocument)(ByVal documentStore As TEventStoreDocument) As UnityContainer
			Dim container = New UnityContainer
			container.RegisterType(Of ITypeResolver, UnityTypeResolver)(New InjectionConstructor(container))
			container.RegisterType(GetType(IBus), GetType(TBus))
			container.RegisterType(GetType(IEventDispatcher), GetType(TBus))

			'container.RegisterType<IBus, InMemoryBus>;
			'container.RegisterType<IEventDispatcher, InMemoryBus>;
			container.RegisterType(Of IRepository, Repository)(New InjectionConstructor(GetType(TEventStore)))

			'container.RegisterType<IRepository, Repository>(
			'    new InjectionConstructor(typeof(EmbeddedRavenDbEventStore)));

			container.RegisterType(GetType(IEventStore), GetType(TEventStore), New InjectionConstructor(GetType(TEventStoreDocument), GetType(IEventDispatcher)))
			'container.RegisterType<IEventStore, EmbeddedRavenDbEventStore>(
			'    new InjectionConstructor(typeof(EmbeddableDocumentStore), typeof(IEventDispatcher)));

			container.RegisterInstance(documentStore)

			Return container
		End Function
	End Class
End Namespace
